library ieee;

use ieee.std_logic_1164.all;
use ieee.numeric_std.all;


entity TestGenerator is
	port
	(
	     CLK : in std_logic;
        nRST : in std_logic;	  
		  GenOut : out std_logic
	);
end;
	
	
architecture arch of TestGenerator is

	constant pulse_length : unsigned(15 downto 0) := to_unsigned(19,16);

	signal en : std_logic;
	signal burst : std_logic;


begin

	process(CLK, nRST)
		variable counter : unsigned(31 downto 0);
		variable counter2 : unsigned(15 downto 0);
	begin
	
			if(nRST = '0') then
			counter := (others => '0');
			counter2 := (others => '0');

      elsif (CLK='1' and CLK'event) then
			if(en = '0') then
				if(counter >= (500000 - 1)) then
					counter := (others => '0');
					burst <= '1';
					
				else
					counter := counter + 1;
			
				end if;
				
			else
				if(counter2 = pulse_length*8-1) then
					counter2 := (others => '0');
					burst <= '0';
				
				else
					counter2 := counter2 + 1;
			
				end if;
		
			end if;
		end if;

	
	end process;

	
	process(CLK, nRST)
	
		variable counter : unsigned(31 downto 0);
		variable counter2 : unsigned(15 downto 0);
			
	
	begin
	
		if(nRST = '0') then
			counter := (others => '0');
			counter2 := (others => '0');

      elsif (CLK='1' and CLK'event) then
			
			
			if(burst = '1') then
			
			if(en = '0') then
			
				--if(counter >= (unsigned(div) - 1)) then
				if(counter >= (800 - 1)) then	
					counter := (others => '0');
					en <= '1';
					
				else
					counter := counter + 1;
			
				end if;
				
			else
				if(counter2 = pulse_length-1) then
					counter2 := (others => '0');
					en <= '0';
					
				
				else
					counter2 := counter2 + 1;
			
				end if;
		
			end if;
			
			else
				counter := (others => '0');
				counter2 := (others => '0');
			end if;
			
		end if;
		
	end process;
	
	GenOut <= not en;
	
end arch;

