library ieee;
use ieee.std_logic_1164.all;

entity uart_tx is 
port
(
    clk : in std_logic;
    reset : in std_logic;
    start : in std_logic;
    data : in std_logic_vector(7 downto 0);
    txd : out std_logic;
    busy : out std_logic
);
end uart_tx;

architecture struct of uart_tx is
    signal bit_pos : integer range 0 to 9;
    signal DataForTurn : std_logic_vector(7 downto 0);
begin
    process(clk,reset)
    begin
        if(reset = '0') then
            bit_pos <=0;
            txd <= '1';
            busy <= '0';
        elsif (clk'event and clk = '1') then
            if(bit_pos = 0) then
                txd <= '1';
                if(start = '1') then --start vysilani
                    bit_pos <= 1;
                    busy <= '1';
                    txd <= '0'; --start bit
                    DataForTurn <= data;
                else
                    busy <= '0';
                end if;
            elsif (bit_pos = 9) then
                txd <= '1';
                bit_pos <= 0;
            else
                txd <= DataForTurn(bit_pos - 1);
                bit_pos <= bit_pos + 1;
            end if;
        end if;
    end process;
end struct;
